
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>
#include <math.h>

#if SOL || HP
#include <sys/time.h>
#include <sys/resource.h>
#endif

#include "jgofs.h"

int JG_HTDoConnect();
int JG_HTDoRead();

/*
  These three functions are callbacks needed by the HTTP code also in this
  file's directory. 
*/

int
JG_HTCheckActiveIcon(int i)
{
    return 0;
}

void
JG_HTClearActiveIcon()
{
}

void
JG_HTProgress(char *msg)
{
#if 0
    fprintf(stderr, "%s\n", msg);
#endif
}

struct OBJECT {
    char htbuff[HTSIZE];
    int htbufflen;
    int htbuffptr;
    int socket;
    int maxlevel, ntotal;
    int lvlpntr[11];
    int rdpntr[NUMNAMES];
    char attributes[NUMNAMES][ATTRSIZE], *attributeptr[NUMNAMES];
    char comments[COMMENTSIZE], *commentptr;
    char error[COMMENTSIZE], *errorptr;
} *object[MAX_UNITS] = {
NULL, NULL, NULL, NULL, NULL};

static int
bgets(char *comm, int len, struct OBJECT *obj)
{
    int op;
    char c;
    /*
       printf("entered bgets\n");
     */
    if (obj->htbufflen < 0)
	return 1;
    op = 0;
    while (1) {
	if (obj->htbuffptr >= obj->htbufflen) {
	    obj->htbufflen = JG_HTDoRead(obj->socket, obj->htbuff, HTSIZE);
	    if (obj->htbufflen == 0) {
		obj->htbufflen = -1;
		return 1;
	    }
	    obj->htbuffptr = 0;
	}
	if ((c = obj->htbuff[obj->htbuffptr++]) != 13)
	    comm[op++] = c;
	if (c == 10) {
	    comm[--op] = 0;
	    return 0;
	}
    }
}

static int
htopen(char *comm, char *par, struct OBJECT *obj)
{
    char *cp, met[MAX_BUF];
    int i, handle;

    cp = strchr(comm + 2, '/');
    if (cp == NULL)
	return -999;
    strcpy(obj->htbuff, "GET /jg/serv/");
    strcat(obj->htbuff, cp + 1);
    *cp = 0;
    if (par) {
	if (*par) {
	    strcat(obj->htbuff, "?");
	    strcat(obj->htbuff, par);
	}
    }
    strcpy(met, "http:");
    strcat(met, comm);
    i = JG_HTDoConnect(met, "HTTP", 80, &handle);
    if (i) {
	printf("Connect to %s failed\n", met);
	return -999;
    }
    obj->socket = handle;
    cp = obj->htbuff + strlen(obj->htbuff);
    *(cp++) = 13;
    *(cp++) = 10;
    *cp = 0;
    write(handle, obj->htbuff, strlen(obj->htbuff));
    return 0;
}

static int
localopen(char *comm, char *par, struct OBJECT *obj)
{
#if 0
    char *cp, met[MAX_BUF];
#endif
    int i;			/* , handle; */
#if 0
    FILE *cin, *cout;
#endif
    static int pipeto[2], pipefrom[2];
    char *parptr[250], *sp;
    int j, np, childpid, numfds;
#if SOL || HP
    struct rlimit rlp;
#endif
    j = 0;
    parptr[j] = comm;
    if (*par) {
	parptr[++j] = par;
	np = 0;
	sp = par + 1;
	while (*sp) {
	    switch (*sp) {
	    case '(':
		np++;
		break;
	    case ')':
		np--;
		break;
	    case ',':
		if (np)
		    break;
		*sp = 0;
		parptr[++j] = sp + 1;
		break;
	    }
	    sp++;
	}
    }
    parptr[++j] = NULL;

    if (pipe(pipeto) || pipe(pipefrom) < 0) {
	perror("no pipes");
	return -999;
	/*exit(1); */
    }

    switch (childpid = fork()) {
    case -1:
	perror("bad fork");
	return -999;
	/*exit(1); */
    case 0:
	/*    printf("got here after fork\n"); */
	dup2(pipeto[0], 0);
	dup2(pipefrom[1], 1);
#if SOL || HP
	getrlimit(RLIMIT_NOFILE, &rlp);
	numfds = rlp.rlim_cur;
#else
	numfds = getdtablesize();
#endif
	for (i = 3; i < numfds; i++)
	    close(i);

	execvp(comm, parptr);
	perror(comm);
	return -999;
	/*    exit(1); */
    default:
	close(pipeto[0]);
	close(pipefrom[1]);
	/*    ptoch = pipeto[1]; */
	/*    pfrch = pipefrom[0]; */
	obj->socket = pipefrom[0];
	/*    setbuf(frch,NULL); */
	return 0;
    }
}

int
ljdbopen_(int *unit, const char *objpath, const char *metpath,
	  const char *obj, char *names, const int *namesize, int *num)
{
    int i, j, k, numd, tunit;
    char comm[MAX_BUF], met[MAX_BUF], par[MAX_BUF], state, *cp, *ap;
    struct OBJECT *o;

    for (tunit = 0; tunit < MAX_UNITS; tunit++)
	if (!object[tunit])
	    break;
    if (tunit >= MAX_UNITS) {
	printf("Out of units");
	return -999;
    }
    o = (struct OBJECT *) malloc(sizeof(struct OBJECT));
    object[tunit] = o;
    *unit = tunit;
    *(o->error) = '\0';
    o->errorptr = o->error;

    strcpy(comm, obj);
    numd = *num;
    if (*num < 0)
	*num = 0;
    else {
	if (comm[strlen(comm) - 1] == ')')
	    comm[strlen(comm) - 1] = ',';
	else
	    strcat(comm, "(");
	for (i = 0; i < numd; i++) {
	    strcat(comm, names + i * (*namesize));
	    strcat(comm, ",");
	}
	comm[strlen(comm) - 1] = ')';
    }
    /*
       printf("++%s++\n",comm);
     */

    /* find it */
    if ((cp = strchr(comm, '('))) {
	strcpy(par, cp + 1);
	*cp = 0;
	par[strlen(par) - 1] = 0;
    }
    else
	*par = 0;
    if (ldctsearch(objpath, metpath, comm, met, par, 1) == 0) {
	/* printf("&x <b>Error - not found:</b> %s %s\n",met,comm); */
	sprintf(o->errorptr, "l_jdbopen, dctsearch, not found:</b> %s %s",
		met, comm);
	return -999;
	/*exit(1); */
    }

    if (strstr(met, "//") == met) {
	if (htopen(met, par, o)) {
	    /*printf("&x <b>Error opening remote object:</b> %s\n",met); */
	    sprintf(o->errorptr,
		    "l_jdbopen, jg_htopen, error opening remote object: %s",
		    met);
	    return -999;
	}
	tunit = 0;
    }
    else {
	if (localopen(met, par, o)) {
	    /*printf("&x <b>Error opening local object:</b> %s\n",met); */
	    sprintf(o->errorptr,
		    "l_jdbopen, localopen, error opening local object: %s",
		    met);
	    return -999;
	}
	tunit = 1;
    }

    o->htbufflen = 0;
    o->htbuffptr = 0;
    *(o->comments) = '\0';
    o->commentptr = o->comments;


    for (i = 0; i < NUMNAMES; i++) {
	o->rdpntr[i] = -1;
	o->attributeptr[i] = o->attributes[i];
    }
    o->ntotal = 0;

    if (tunit) {
	if (bgets(comm, MAX_BUF - 1, o))
	    return -999;
	if (comm[0] == '&')
	    if (comm[1] == 'x') {
		sprintf(o->errorptr, "l_jdbopen, %s", comm);
		close(o->socket);
		/*free(o);
		 *object[tunit]=NULL;
		 */
		return -999;
	    }
	if (bgets(comm, MAX_BUF - 1, o))
	    return -999;
	if (comm[0] == '&')
	    if (comm[1] == 'x') {
		sprintf(o->errorptr, "l_jdbopen, %s", comm);
		close(o->socket);
		/*free(o);
		 *object[tunit]=NULL;
		 */
		return -999;
	    }
    }
    state = 'c';
    o->maxlevel = 0;
    while (1) {
	if (bgets(comm, MAX_BUF - 1, o))
	    return -999;
	if (comm[0] == '&')
	    state = comm[1];
	switch (state) {
	case 'x':
	    sprintf(o->errorptr, "l_jdbopen, %s", comm);
	    close(o->socket);
	    /*free(o);
	     *object[tunit]=NULL;
	     */
	    return -999;
	case 'e':
	    sprintf(o->errorptr, "l_jdbopen, %s", comm);
	    close(o->socket);
	    /*free(o);
	     *object[tunit]=NULL;
	     */
	    return -999;
	case 'c':
	    if (comm[0] != '&') {
		strcat(o->comments, comm);
		strcat(o->comments, "\n");
	    }
	    break;
	case 'r':
	    if (numd > 0) {
		for (i = 0; i < numd; i++) {
		    for (j = 0; j < o->ntotal; j++)
			if (o->rdpntr[j] == i)
			    break;
		    if (j == o->ntotal) {
			close(o->socket);
			sprintf(o->errorptr, "l_jdbopen &r, %d", j);
			/*free(o);
			 *object[tunit]=NULL;
			 */
			return -(i + 1);
		    }
		}
	    }
	    o->lvlpntr[o->maxlevel + 1] = o->ntotal;
	    return o->maxlevel;
	case 'v':
	    if (comm[0] == '&') {
		o->maxlevel = comm[2] - '0';
		o->lvlpntr[o->maxlevel] = o->ntotal;
	    }
	    else {
		cp = strtok(comm, "\t\n");
		while (cp) {
		    ap = strchr(cp, '[');
		    if (ap) {
			*ap = 0;
			ap++;
			*(ap + strlen(ap) - 1) = ';';
		    }
		    o->ntotal++;
		    if (numd < 0) {
			(*num)++;
			if (*num > -numd) {
			    sprintf(o->errorptr,
				    "l_jdbopen, &v, too many variables: %d",
				    *num);
			    close(o->socket);
			    /*free(o);
			     *object[tunit]=NULL;
			     */
			    return -999;
			}
			strcpy(names + (*namesize) * (*num - 1), cp);
			if (ap)
			    strcpy(o->attributes[*num - 1], ap);
			k = *num - 1;
		    }
		    else {
			k = -1;
			for (i = 0; i < *num; i++)
			    if (strcmp(names + (*namesize) * i, cp) == 0) {
				k = i;
				if (ap)
				    strcpy(o->attributes[i], ap);
			    }
		    }
		    if (k >= 0)
			o->rdpntr[o->ntotal - 1] = k;
		    cp = strtok(NULL, "\t\n");
		}
	    }
	}
    }
}

int
ljdbread_(const int *unit, float values[])
{
    char comm[MAX_BUF], state, *cp;
    int i, k, ilvl, iret;
    struct OBJECT *o;
    if (!(o = object[*unit]))
	return -1;
    ilvl = o->maxlevel;
    iret = ilvl;
    state = 'd';
    while (1) {
	/*   printf(">>%c>>%s\n",state,comm);  */
	if (bgets(comm, MAX_BUF - 1, o))
	    return -1;

	if (comm[0] == '&') {
	    state = comm[1];
	    switch (state) {
	    case 'x':
		sprintf(o->errorptr, "l_jdbread, %s", comm);
		close(o->socket);
		/*free(o);
		 *object[tunit]=NULL;
		 */
		return -999;
	    case 'e':
		sprintf(o->errorptr, "l_jdbread, &e");
		close(o->socket);
		/*free(o);
		 *object[*unit]=NULL;
		 */
		return -1;
	    case 'd':
		ilvl = comm[2] - '0';
		if (ilvl < iret)
		    iret = ilvl;
		break;
	    case 'c':
		*(o->comments) = '\0';
		o->commentptr = o->comments;
	    }
	}
	else {
	    switch (state) {
	    case 'c':
		strcat(o->comments, comm);
		strcat(o->comments, "\n");
		break;
	    case 'd':
		cp = strtok(comm, "\t\n");
		for (i = o->lvlpntr[ilvl]; i < o->lvlpntr[ilvl + 1]; i++) {
		    k = o->rdpntr[i];
		    if (cp && k >= 0) {
			if (strspn(cp, "0123456789.+-") == 0)
			    values[k] = -9999.99;
			else
			    values[k] = atof(cp);
			cp = strtok(NULL, "\t\n");
		    }
		    else if (cp)
			cp = strtok(NULL, "\t\n");
		    else if (k >= 0)
			values[k] = -9999.99;
		}
		if (ilvl == o->maxlevel)
		    return iret;
	    }
	}
    }
}


int
ljdbreada_(const int *unit, char *values, const int *valuesize)
{
    char comm[MAX_BUF], state, *cp;
    int i, k, ilvl, iret;
    struct OBJECT *o;

    if (!(o = object[*unit]))
	return -1;
    ilvl = o->maxlevel;
    iret = ilvl;
    state = 'd';
    while (1) {
	/*   printf(">>%c>>%s\n",state,comm);  */
	if (bgets(comm, MAX_BUF - 1, o))
	    return -1;

	if (comm[0] == '&') {
	    state = comm[1];
	    switch (state) {
	    case 'x':
		sprintf(o->errorptr, "l_jdbreada, %s", comm);
		close(o->socket);
		/*free(o);
		 *object[tunit]=NULL;
		 */
		return -999;
	    case 'e':
		sprintf(o->errorptr, "l_jdbreada, &e");
		close(o->socket);
		/*free(o);
		 *object[*unit]=NULL;
		 */
		return -1;
	    case 'd':
		ilvl = comm[2] - '0';
		if (ilvl < iret)
		    iret = ilvl;
		break;
	    case 'c':
		*(o->comments) = '\0';
		o->commentptr = o->comments;
	    }
	}
	else {
	    switch (state) {
	    case 'c':
		strcat(o->comments, comm);
		strcat(o->comments, "\n");
		break;
	    case 'd':
		cp = strtok(comm, "\t\n");
		for (i = o->lvlpntr[ilvl]; i < o->lvlpntr[ilvl + 1]; i++) {
		    k = o->rdpntr[i];
		    if (cp && k >= 0) {
			strcpy(values + (*valuesize) * k, cp);
			cp = strtok(NULL, "\t\n");
		    }
		    else if (cp)
			cp = strtok(NULL, "\t\n");
		    else if (k >= 0)
			strcpy(values + (*valuesize) * k, "nd");
		}
		if (ilvl == o->maxlevel)
		    return iret;
	    }
	}
    }
}

int
ljdbcomments_(const int *unit, char *outcom)
{
    int j;
    struct OBJECT *o;

    if (!(o = object[*unit]))
	return 0;
    if (*(o->commentptr)) {
	j = strcspn(o->commentptr, "\n");
	strncpy(outcom, o->commentptr, j);
	*(outcom + j) = '\0';
	o->commentptr += j + 1;
	return 1;
    }
    else
	return 0;
}

int
ljdbattributes_(const int *unit, int *id, char *outcom)
{
    int j;
    char *sp;
    struct OBJECT *o;

    if (!(o = object[*unit]))
	return 0;
    sp = o->attributeptr[*id];
    if (*sp) {
	j = strcspn(sp, ";");
	strncpy(outcom, sp, j);
	*(outcom + j) = '\0';
	o->attributeptr[*id] += j + 1;
	return 1;
    }
    else
	return 0;
}

void
ljdbclose_(const int *unit)
{
    struct OBJECT *o;

    if (!(o = object[*unit]))
	return;
    close(o->socket);
    free(o);
    object[*unit] = NULL;
}

int
ljdblevel_(const int *unit, int *varnum)
{
    int i, j;
    struct OBJECT *o;

    if (!(o = object[*unit]))
	return -1;		/* this was `return;' I added the -1 01/14/03
				   jhrg */
    for (j = 0; j < o->ntotal; j++)
	if (*varnum == o->rdpntr[j])
	    break;

    if (j >= o->ntotal)
	return -1;

    for (i = 1; i <= o->maxlevel; i++)
	if (j < o->lvlpntr[i])
	    return i - 1;

    return o->maxlevel;
}

/**
   @param jdbError really char *[1024]. */
int
ljdberror_(const int *unit, char *jdbError)
{
    struct OBJECT *o;

    if (!(o = object[*unit])) {
	strcpy(jdbError, "jgofs, empty object");
	return -1;
    }
    else {
	strcpy(jdbError, o->errorptr);
	return 1;
    }
}

#ifdef ULTRIX
char *
strdup(s)
char *s;
{
    char *t;
    if (s == NULL)
	return NULL;
    t = malloc(strlen(s) + 1);
    strcpy(t, s);
    return t;
}
#endif
